package gotowe.p20_string;

import java.util.Objects;

public class Porownywanie {

	public static void main(String[] args) {
		String ala = "Ala";
		final String final_ala = "Ala";
		
		String a = "Ala ma kota";
		String b = "Ala ma kota";
		String c = "Ala" + " ma kota";
		String d = final_ala + " ma kota";
		//String e = InnaKlasa.dajStringaZKodu();
		// ↑ Do tych zmiennych wpisywany jest adres tego samego obiektu String.
		// Jest to optymalizacja wykonywana przez kompilator Javy (i JVM - tzw. "pula stałych") 
		
		String f = new String(a);
		String g = ala + " ma kota";
		// Do f i g wpisywane są nowe obiekty, które są pod innym adresem w pamięci, niż a
		// tak samo jest dla danych wczytywanych z zewnętrznych źródeł: konsola, plik, baza danych
		
		// wszystkie zmienne od a do g zawierają ten sam tekst
		System.out.println(a);
		System.out.println(b);
		System.out.println(c);
		System.out.println(d);
		System.out.println(f);
		System.out.println(g);
		System.out.println();
		
		// Mimo tego, porównanie == czasami daje wynik true, ale czasami false
		System.out.println("==");
		System.out.println(a == "Ala ma kota");
		System.out.println(a == a);
		System.out.println(a == b);
		System.out.println(a == c);
		System.out.println(a == d);
		System.out.println(a == f);
		System.out.println(a == g);
		System.out.println();
		
		System.out.println("intern");
		// intern zwraca referencję do stringa o takiej samej treści, ale pochodzącego z puli stringów
		// jeśli w puli jeszcze go nie było, to dodawany
		System.out.println(a.intern() == f.intern());
		System.out.println();
		
		// Najwłaściwszym sposobem porównywania tekstów w Javie jest metoda equals
		// Ona sprawdza czy napisy mają tę samą treść.
		// Mamy też equalsIgnoreCase , który ignoruje wielkość liter
		System.out.println("equals");
		System.out.println(a.equals(a));
		System.out.println(a.equals(b));
		System.out.println(a.equals(c));
		System.out.println(a.equals(d));
		System.out.println(a.equals(f));
		System.out.println(a.equals(g));
		System.out.println("Ala ma kota".equals(g));
		System.out.println(Objects.equals(a, g));
		System.out.println();
		
		System.out.println("hash:");
		System.out.println(a.hashCode());
		System.out.println(b.hashCode());
		System.out.println(c.hashCode());
		System.out.println(d.hashCode());
		System.out.println(f.hashCode());
		System.out.println(g.hashCode());
	}

}
