package p08_funkcje;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class SilniaTest {

    @Test
    void testSilnia5() {
        long wynik = Silnia.silnia(5);
        // W języku Java (podobnie jak w Python) istnieje słowo kluczowe assert
        // Gdy warunek jest prawdą → nic się nie dzieje, program idzie dalej
        // Gdy warunek jest fałszywy → wyrzucany jest wyjątek AssertionError,
        // a JUnit wyłapuje ten wyjątek i informuje, że test skończył się porażką.
        // Tak pisany assert działa tylko w trybie testowania, a (gdyby wystąpił w normalnym kodzie),
        // jest pomijany "na produkcji".
        // assert wynik == 120;

        // W testach zdecydowanie częściej używa się dedykowanych asercji, które dają bardziej precyzyjne komunikaty, co się nie zgadza.
        // assertEquals(wartośćOczekiwana, wartośćFaktyczna)
        // to najczęściej używany rodzaj asercji w bibliotece JUnit.
        assertEquals(120, wynik);
    }

    @Test
    void testSilnia0() {
        long wynik = Silnia.silnia(0);
        assertEquals(1, wynik);
    }

    @Test
    void testSilnia20() {
        long wynik = Silnia.silnia(20);
        assertEquals(2432902008176640000L, wynik);
    }

}